package org.apache.commons.lang3.time;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.io.IOException;
import java.util.Calendar;
import org.apache.commons.lang3.time.FastDatePrinter;

class Iso8601_Rule implements FastDatePrinter.Rule {
  static final Iso8601_Rule ISO8601_HOURS = new Iso8601_Rule(3);
  
  static final Iso8601_Rule ISO8601_HOURS_MINUTES = new Iso8601_Rule(5);
  
  static final Iso8601_Rule ISO8601_HOURS_COLON_MINUTES = new Iso8601_Rule(6);
  
  final int length;
  
  static Iso8601_Rule getRule(int tokenLen) {
    switch (tokenLen) {
      case 1:
        return ISO8601_HOURS;
      case 2:
        return ISO8601_HOURS_MINUTES;
      case 3:
        return ISO8601_HOURS_COLON_MINUTES;
    } 
    throw new IllegalArgumentException("invalid number of X");
  }
  
  Iso8601_Rule(int length) {
    this.length = length;
  }
  
  public int estimateLength() {
    return this.length;
  }
  
  public void appendTo(Appendable buffer, Calendar calendar) throws IOException {
    int offset = calendar.get(15) + calendar.get(16);
    if (offset == 0) {
      buffer.append("Z");
      return;
    } 
    if (offset < 0) {
      buffer.append('-');
      offset = -offset;
    } else {
      buffer.append('+');
    } 
    int hours = offset / 3600000;
    FastDatePrinter.access$000(buffer, hours);
    if (this.length < 5)
      return; 
    if (this.length == 6)
      buffer.append(':'); 
    int minutes = offset / 60000 - 60 * hours;
    FastDatePrinter.access$000(buffer, minutes);
  }
}
